structure BuildAst :
sig 
	val compile : string -> Exp.exp
        val BuildAstError : exn
end =
struct
exception BuildAstError;

fun compile (fileName) = 
    let val inStream =  TextIO.openIn fileName;
        val grab : int -> string = fn 
            n => if TextIO.endOfStream inStream 
                 then ""
                 else TextIO.inputN (inStream,n);

        val printError : string * int * int -> unit = fn  (msg,line,col) => raise BuildAstError;

        val (tree,rem) = BuildAstParser.parse 
                     (15,
                     (BuildAstParser.makeLexer grab fileName),
                     printError,
                     fileName)
            handle BuildAstParser.ParseError => raise BuildAstError;
        (* Close the source program file *)
        val _ = TextIO.closeIn inStream;
    in tree
    end
end;
