open Exp;	
%%
%name BuildAst

%term LPAREN
	| RPAREN
	| NEW
	| NUM of int
	| IDENTIFIER of string 
	| PLUS | MINUS
	| MULT | DIV | MOD
	| EOF

%nonterm Line of exp
	| Aexp of exp
	| Term of exp
	| Factor of exp
	| AOP of exp*exp -> exp
	| MOP of exp*exp -> exp

%pos int
%eop EOF
%noshift EOF
%nodefault
%verbose
%arg (fileName) : string

%%
Line : Aexp					(Aexp)
	|Aexp NEW				(Aexp)
Aexp : Term AOP Aexp			(AOP(Term,Aexp))
	|Term					(Term)
AOP :  PLUS					(PLUS)
	|MINUS				(MINUS)
Term : Factor MOP Term			(MOP(Factor,Term))
	|Factor				(Factor)
MOP :  MULT					(MULT)
	|DIV					(DIV)
	|MOD					(MOD)
Factor : LPAREN Aexp RPAREN		(Aexp)
	| NUM					(N(NUM))
	| IDENTIFIER			(V(IDENTIFIER))