open DataTypes ;
%%
%name BuildAst

%term NEW
    | LPAREN
    | RPAREN
    | LBRACE
    | RBRACE
    | ASMT
    | COMMA
    | PROGRAM
    | PROC
    | ASSIGN
    | VAR
    | PARAM
    | IDENTIFIER of string
    | REAL of real
    | NUM of int
    | EMPTY
    | EOF

%nonterm Pgm of procedure
	|Code of (string list)*((string * int) list)*(procedure list)
	|Vardec of string list
	|varlist of string list
	|Assgn of (string * int) list
	|aslist of (string * int) list
	|Procdec of procedure list
	|proc of procedure
	|Param of string list

%pos int
%eop EOF
%noshift EOF
%nodefault
%verbose
%arg (fileName) : string

%%

Pgm : PROGRAM IDENTIFIER LPAREN RPAREN LBRACE Code RBRACE	(P(IDENTIFIER,([],Code)))

Code : Assgn							([],Assgn,[])
     | Vardec Assgn						(Vardec,Assgn,[])
     | Vardec Assgn Procdec					(Vardec,Assgn,Procdec)

Vardec : VAR varlist NEW					(varlist)

varlist : IDENTIFIER						([IDENTIFIER])
	| IDENTIFIER COMMA varlist 				((IDENTIFIER)::(varlist))

Assgn : ASSIGN aslist NEW					(aslist)

aslist : IDENTIFIER ASMT NUM 					([(IDENTIFIER,NUM)])
	|IDENTIFIER ASMT NUM COMMA aslist			((IDENTIFIER,NUM)::(aslist))

Procdec : proc							([proc])
	| proc Procdec						((proc)::(Procdec))

proc : PROC IDENTIFIER LPAREN RPAREN LBRACE Code RBRACE		(P(IDENTIFIER,([],Code)))
proc : PROC IDENTIFIER LPAREN Param RPAREN LBRACE Code RBRACE	(P(IDENTIFIER,(Param,Code)))

Param : PARAM varlist						(varlist)
